<!DOCTYPE html>
<html lang="en"><head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
		<title>three.js webgl - lines - cubes</title>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0">
		<style>
			body {
				background-color: #000000;
				margin: 0px;
				overflow: hidden;
			}

			a {
				color:#0078ff;
			}

			#info {
				position: absolute;
				top: 10px; width: 100%;
				color: #ffffff;
				padding: 5px;
				font-family: Monospace;
				font-size: 13px;
				text-align: center;
				z-index:100;
			}

			a {
				color: orange;
				text-decoration: none;
			}

			a:hover {
				color: #0080ff;
			}

		</style>
	</head>
	<body>
		<div id="info">
			[<a href="http://en.wikipedia.org/wiki/Hilbert_curve">Hilbert curve</a> mapping of Ethereum private keys to public keys and public addresses.]
		</div>

		<script src="three.js"></script>
		<script src="hilbert3D.js"></script>
		<script src="Detector.js"></script>
		<script src="stats.js"></script>
		<script src='threex.rendererstats.js'></script>
		<script src='keythereumPATCHED.js'></script>

<script>

			
			var USE_STATS = true;  //false here disables stats displays

			var rendererStats	= new THREEx.RendererStats()
			rendererStats.domElement.style.position	= 'absolute'
			rendererStats.domElement.style.left	= '0px'
			rendererStats.domElement.style.bottom	= '0px'
			if(USE_STATS){document.body.appendChild( rendererStats.domElement )}

			var stats = new Stats();
			stats.showPanel( 0 );
			stats.dom.style.position = 'absolute';
			stats.dom.style.float = 'right';
			stats.dom.style['top'] = (window.innerHeight-50)+'px';
			stats.dom.style['right'] = '5px';
			stats.dom.style['left'] = null;
			if(USE_STATS){document.body.appendChild( stats.dom );}


			var mouseX = 0, mouseY = 0,
			windowHalfX = window.innerWidth / 2,
			windowHalfY = window.innerHeight / 2,
			camera, scene, renderer;

			var newConTripleHELPER = [];

			var hilbertIterations = 4;

			var globalKeyCount = 0;

			var TXT_vertical = 700;
			var loader = new THREE.FontLoader();

			function TXT_ME ( TXT , TXT_color , linkedTripleLine) {
				loader.load( 'optimer_regular.typeface.json', function ( font ) {
					var xMid = -650;
					var text;
					var textShape = new THREE.BufferGeometry();
					var color = TXT_color //0x006699;
					var matDark = new THREE.LineBasicMaterial( {
						color: color,
						side: THREE.DoubleSide
					} );
					var matLite = new THREE.MeshBasicMaterial( {
						color: color,
						transparent: true,
						opacity: 0.4,
						side: THREE.DoubleSide
					} );
					var message = TXT;
					var shapes = font.generateShapes( message, 50, 0 ); // final can be 0, see no diff?

					/*
					console.log("before",shapes);
					for(var i = shapes.length;i>10;i--) {
						shapes.pop()
					}
					console.log("after",shapes);
					*/ // reducing the size of the strings DOES get rid of the rendering jitter

					var _TXT1 = function(){

							//SLOWNESS LOCATED
							//var geometry = new THREE.ShapeGeometry( shapes /*, 0*/); // this is the slowness
							// adding (,0) to the args makes the shapes have 0 curve segments // three.js line 28906
							//SLOWNESS LOCATED

							//Alternative for testing

							var geometry = new THREE.ShapeGeometry(shapes/*,0*/);
							//for ( var i = 1; i < shapes.length; i ++ ) {
							//	geometry.addShape(shapes[i]);
							//}


							geometry.translate( xMid, -500, 0 );

							textShape.fromGeometry( geometry );

							text = new THREE.Mesh( textShape, matLite );

							text.position.z = - 150;
							var rrrandomize = function rrrandomize () {
								text.rotation.x = Math.random()
								text.rotation.y = Math.random()
								text.rotation.z = Math.random()
								if(Math.random()>0.5){text.rotation.x *= -1}
								if(Math.random()>0.5){text.rotation.y *= -1}
								if(Math.random()>0.5){text.rotation.z *= -1}
								text.scale.x = Math.random()*2
								text.scale.y = Math.random()*2
								text.scale.z = Math.random()*2
								if(Math.random()>0.5){text.scale.x *= -1}
								if(Math.random()>0.5){text.scale.y *= -1}
								if(Math.random()>0.5){text.scale.z *= -1}
							};
							rrrandomize();

							text.tag = "text1";
							text.linkedTripleLine = linkedTripleLine;
							scene.add( text );
					};
					_TXT1();

					var _TXT2 = function(){
							var holeShapes = [];
							for ( var i = 0; i < shapes.length; i ++ ) {
								var shape = shapes[ i ];
								if ( shape.holes && shape.holes.length > 0 ) {
									for ( var j = 0; j < shape.holes.length; j ++ ) {
										var hole = shape.holes[ j ];
										holeShapes.push( hole );
									}
								}
							}
							shapes.push.apply( shapes, holeShapes );
							var lineText = new THREE.Object3D();
							for ( var i = 0; i < shapes.length; i ++ ) {
								var shape = shapes[ i ];
								var points = shape.getPoints();
								var geometry = new THREE.BufferGeometry().setFromPoints( points );

								geometry.translate( xMid, 500, Math.random()*10 );
								var lineMesh = new THREE.Line( geometry, matDark );
								lineText.add( lineMesh );
							}
							lineText.tag = "text2";
							lineText.position.z = (Math.random()*(-80) + Math.random()*(30))
						//	lineText.position.x = xMid*1.5*Math.random();
							lineText.linkedTripleLine = linkedTripleLine;
							scene.add( lineText );
					}
					_TXT2()
				} ); //end load function
			}

			TXT_ME("Ethereum KeyScape Ethereum KeyScape Ethereum KeyScape Ethereum KeyScape")


			function queryAddressForTransactions ( queryAddress , addressPrivKey) {
				  var xhttp = new XMLHttpRequest();
					var returner;
				  xhttp.onreadystatechange = function() {
				    if (this.readyState == 4 && this.status == 200) {
							returner = JSON.parse(this.responseText);
							if (returner.status == 0){
								console.log(returner.message,/*this.responseURL,*/"Key:",addressPrivKey,"@", 'https://etherscan.io/address/' + queryAddress); //api accepts malformed addresses, this is a safety check
							} else {
								console.log(this.responseText,this.responseURL,"Key:",addressPrivKey,"@", 'https://etherscan.io/address/' + queryAddress);
								winCondition(queryAddress,addressPrivKey);
							}
						}
				  };
				  xhttp.open("POST", "https://api.etherscan.io/api?module=account&action=txlist&address=" + queryAddress, true);
				  xhttp.send();
					return returner;
			}

			function winCondition ( queryAddress, addressPrivKey ) {
				// 1) Send notification - IFTTT to SMS and email - working
							// send {key, address, front-end-url}, get email with all, and SMS with URL and KEY from IFTTT

				// 2) Send transaction
							// form transaction to occur in next block
							// Make sure to make realistic calculations in forming the block - this is where mistakes happen
							// Test this (maybe use testnet code for verification testing)
							// sign it, add it to the pool using etherscan
							// Make vanity address like deaddead...deaddead

				var xhttp = new XMLHttpRequest();
				xhttp.onreadystatechange = function() {
					if (this.readyState == 4 && this.status == 200) {
						console.log(JSON.parse(this.responseText))
					}
				};
				var urly = 'https://etherscan.io/address/' + queryAddress;
				// This sends the keys to IFTTT, which sends SMS&Email
				xhttp.open("POST", "https://maker.ifttt.com/trigger/ethkeyscape/with/key/flo0JpVWxY__xfpWpvfzjd2DkedvszOjmEJbIY1dshb" + "?" + 'value1='+addressPrivKey+"&value2="+queryAddress+"&value3="+'"'+urly+'"', true);
				// the CORS problems are just firefox warning/errors, notifications seem to be functioning
				xhttp.send();

				victoryTransaction(queryAddress,addressPrivKey);

				// Make a little ruckus
				for (var i = 0; i < 50; i++) {
				  console.log("WINNER WINNER CHICKEN DINNER!", queryAddress, addressPrivKey, "<<=== HOT FRESH KEYS!", i);
			  }

			}

			function victoryTransaction (victoryAddress, victoryKey) {
							// form transaction to occur in next block
							// Make sure to make realistic calculations in forming the block - this is where mistakes happen
							// Test this (maybe use testnet code for verification testing)
							// sign it, add it to the pool using etherscan
							// Make vanity address like deaddead...deaddead
			}

			function mintKeysAndMap () {
				// Mint a set of ethereum keys
				var keychain = newKeychain();
				//query etherscan
				queryAddressForTransactions(keychain.addr,keychain.priv);

				// Map them on the KeyScape
				var mapping = keysToMappings(hilbertIterations,keychain.priv,keychain.pub,keychain.addr);
				// Reify mapping
				//break this display code into another function
				var mappedTriple = makeNewREALConnection(mapping.privkeyMap, mapping.pubkeyMap, mapping.pubaddressMap);
				//console.log(mappedTriple);
				//console.log(mappedTriple.material.color) // good so far. Now make the text that colour, in the background
				//setTimeout( TXT_ME(JSON.stringify(keychain),mappedTriple.material.color,mappedTriple), 300);
				//
				// step 3.5: display numbers onscreen in same colour as connector
				//
				//my own text is the true laggard? could it be?

				//TXT_ME(JSON.stringify(keychain),mappedTriple.material.color,mappedTriple)
				//TXT_ME(JSON.stringify(keychain.priv),mappedTriple.material.color,mappedTriple) //just priv
				TXT_ME(keychain.priv.slice(28,-1),mappedTriple.material.color,mappedTriple) //not even all of priv


				globalKeyCount += 1;
				if (globalKeyCount == 1000000) {millionKeysNotifier()}
				//setTimeout(mintKeysAndMap(),3500);
				//setTimeout(mintKeysAndMap,3500);
			}

			function newKeychain () {
			  var dk = keythereum.create();
			  var ethAddress = keythereum.privateKeyToAddress(dk.privateKey);
			  var ethPubkey = keythereum.privateKeyToPublic(dk.privateKey);
			  return {priv:dk.privateKey.toString('hex'),pub:ethPubkey,addr:ethAddress};
			}

			function millionKeysNotifier () {
				// Works correctly

				var xhttp = new XMLHttpRequest();
				xhttp.onreadystatechange = function() {
					if (this.readyState == 4 && this.status == 200) {
						console.log(JSON.parse(this.responseText))
					}
				};
				// This sends "One Million Keys!" to IFTTT, which sends SMS&Email
				xhttp.open("POST", "https://maker.ifttt.com/trigger/ethkeyscape/with/key/flo0JpVWxY__xfpWpvfzjd2DkedvszOjmEJbIY1dshb" + "?" + 'value1='+"One Million Keys!"+"&value2="+"Holy Cow!"+"&value3="+"That's a lot of keys!", true);
				// the CORS problems are just firefox warning/errors, notifications seem to be functioning
				xhttp.send();
			}

			//keysToMappings accepts keys, outputs vertex array indices
			var keysToMappings = function keysToMappings ( hilbertIterations, privkey, pubkey, pubaddress ) {

						var _key1 = "" + privkey.toString('hex');
						var map1 = 0;
						for ( var i = 0; i < hilbertIterations; i++) {
							map1 += ((~~(parseInt(_key1.charAt(i*(~~(_key1.length/hilbertIterations))),16)/2))*(8**(hilbertIterations-i)));
						}

						var _key2 = "" + pubkey.toString('hex');
						var map2 = 0;
						for ( var i = 0; i < hilbertIterations; i++) {
							map2 += ((~~(parseInt(_key2.charAt(i*(~~(_key2.length/hilbertIterations))),16)/2))*(8**(hilbertIterations-i)));
						}

						if ( pubaddress.slice(0,2) == "0x" ) {pubaddress = pubaddress.slice(2,-1)};
						var _key3 = "" + pubaddress
						var map3 = 0;
						for ( var i = 0; i < hilbertIterations; i++) {
							map3 += ((~~(parseInt(_key3.charAt(i*(~~(_key3.length/hilbertIterations))),16)/2))*(8**(hilbertIterations-i)));
						}
					//	console.log(_key1, map1, _key2, map2, _key3, map3)

				return {privkeyMap: map1, pubkeyMap: map2, pubaddressMap: map3};
			}

			// creates a new line connecting 1 vertex on each of 3 cubes and adds it to the scene
			var newConnectionTriple = function newConnectionTriple ( privkeyCube, privkeyMap, pubkeyCube, pubkeyMap, pubaddressCube, pubaddressMap ) {
				var privkeyVertex = privkeyCube.geometry.vertices[privkeyMap].clone()
				var pubkeyVertex = pubkeyCube.geometry.vertices[pubkeyMap].clone()
				var pubaddressVertex = pubaddressCube.geometry.vertices[pubaddressMap].clone()

				var connectionTripleGeo = new THREE.Geometry();
				connectionTripleGeo.vertices.push(privkeyVertex);
				connectionTripleGeo.vertices.push(pubkeyVertex);
				connectionTripleGeo.vertices.push(pubaddressVertex);
				var connectionTriple = new THREE.LineLoop(connectionTripleGeo);
				connectionTriple.scale.x = connectionTriple.scale.y = connectionTriple.scale.z =  1;
				connectionTriple.position.x = connectionTriple.position.y = connectionTriple.position.z = 0;

				connectionTriple.selfUpdateVertices = function selfUpdateVertices () {
					connectionTriple.geometry.vertices[0] = privkeyVertex.clone().applyMatrix4(privkeyCube.matrixWorld);
					connectionTriple.geometry.vertices[1] = pubkeyVertex.clone().applyMatrix4(pubkeyCube.matrixWorld);
					connectionTriple.geometry.vertices[2] = pubaddressVertex.clone().applyMatrix4(pubaddressCube.matrixWorld);
				}
				connectionTriple.selfUpdateVertices();
				scene.add(connectionTriple);
				//console.log(connectionTriple);
				return connectionTriple;
			}

			function makeNewMockConnection() {
				newConnectionTriple(newConTripleHELPER[0],(~~(Math.random()*4096)),newConTripleHELPER[1],(~~(Math.random()*4096)),newConTripleHELPER[2],(~~(Math.random()*4096)))
			};

			function makeNewREALConnection(priv, pub, addr) {
				//console.log("makeNewREALConnection",priv,pub,addr);
				return newConnectionTriple(newConTripleHELPER[0],priv,newConTripleHELPER[1],pub,newConTripleHELPER[2],addr);
			}


			function init() {

				var i, container;

				container = document.createElement( 'div' );
				document.body.appendChild( container );

				camera = new THREE.PerspectiveCamera( 33, window.innerWidth / window.innerHeight, 1, 10000 );
				camera.position.z = 700;
				camera.zoom = 1.6;

				scene = new THREE.Scene();

				renderer = new THREE.WebGLRenderer();
				renderer.setPixelRatio( window.devicePixelRatio );
				renderer.setSize( window.innerWidth, window.innerHeight );
				container.appendChild( renderer.domElement );


				var geometry = new THREE.Geometry(),
					points = hilbert3D( new THREE.Vector3( 0,0,0 ), 200.0, hilbertIterations, 0, 1, 2, 3, 4, 5, 6, 7 );

				for ( i = 0; i < points.length; i ++ ) {
					geometry.vertices.push( points[i] );
				}

				// lines
				var line, p, scale = 0.5, d = 125, c1 = 0x553300, c2 = 0x555555, c3 = 0x992800, g1 = geometry,
					m1 = new THREE.LineBasicMaterial( { color: c1, opacity: 1, blending: THREE.AdditiveBlending, transparent: true } ),
					m2 = new THREE.LineBasicMaterial( { color: c2, opacity: 0.5, blending: THREE.AdditiveBlending, transparent: true } ),
					m3 = new THREE.LineBasicMaterial( { color: c3, opacity: 1, blending: THREE.AdditiveBlending, transparent: true } ),

					parameters =
										[
											[ m1, scale, [-d, 0, 0],  g1 ],
											[ m2, scale, [d, 0, 0],  g1 ],
											[ m3, scale*.5, [d,0,0],  g1 ]
								   ];

				for ( i = 0; i < parameters.length; i ++ ) {

					p = parameters[ i ];

					line = new THREE.Line( p[ 3 ],  p[ 0 ] );

					line.scale.x = line.scale.y = line.scale.z =  p[ 1 ];

					line.position.x = p[ 2 ][ 0 ];
					line.position.y = p[ 2 ][ 1 ];
					line.position.z = p[ 2 ][ 2 ];

					scene.add( line );
					newConTripleHELPER.push( line );
				}

				document.addEventListener( 'mousemove', onDocumentMouseMove, false );
				document.addEventListener( 'touchstart', onDocumentTouchStart, false );
				document.addEventListener( 'touchmove', onDocumentTouchMove, false );

				window.addEventListener( 'resize', onWindowResize, false );

			}

			function onWindowResize() {

				windowHalfX = window.innerWidth / 2;
				windowHalfY = window.innerHeight / 2;

				camera.aspect = window.innerWidth / window.innerHeight;
				camera.updateProjectionMatrix();

				renderer.setSize( window.innerWidth, window.innerHeight );

			}

			function onDocumentMouseMove(event) {

				mouseX = event.clientX - windowHalfX;
				mouseY = event.clientY - windowHalfY;
			}

			function onDocumentTouchStart( event ) {

				if ( event.touches.length > 1 ) {

					event.preventDefault();

					mouseX = event.touches[ 0 ].pageX - windowHalfX;
					mouseY = event.touches[ 0 ].pageY - windowHalfY;

				}

			}

			function onDocumentTouchMove( event ) {

				if ( event.touches.length == 1 ) {

					event.preventDefault();

					mouseX = event.touches[ 0 ].pageX - windowHalfX;
					mouseY = event.touches[ 0 ].pageY - windowHalfY;

				}

			}

			function animate() {
				requestAnimationFrame( animate );
				if(USE_STATS){stats.update();}
				if(USE_STATS){rendererStats.update(renderer);}

				render();

				//culling
				if ( scene.children.length > 200) {
					console.log("culling")
					for ( var i = 10; i < scene.children.length; i ++ ) {
						var object = scene.children[ i ];
						//if (object.selfUpdateVertices) {
							if (Math.random() > 0.001 ) {
								scene.remove(scene.children[i]);
							}
						//}
					}
				}
			}

			function render() {

				camera.position.x += ( mouseX - camera.position.x ) * .05;
				camera.position.y += ( - mouseY + 200 - camera.position.y ) * .05;

				camera.lookAt( scene.position );

				var time = Date.now() * 0.0015;

				// spin - moved out of loop
				newConTripleHELPER[0].rotation.y = time/2;
				newConTripleHELPER[2].rotation.y = time/2;
				newConTripleHELPER[1].rotation.y = -time/3; newConTripleHELPER[1].rotation.z = -time/2; newConTripleHELPER[1].rotation.x = -time/7;

				for ( var i = 0; i < scene.children.length; i ++ ) {

					var object = scene.children[ i ];

					// text
					if ( object.tag == "text1" ) {object.position.y += 1; if (object.position.y >= 1400){scene.remove(object)}}
					if ( object.tag == "text2" ) {object.position.y -= 1; if (object.position.y <= -1400){scene.remove(object);scene.remove(object.linkedTripleLine)}}

					//update the connections
					if (object.selfUpdateVertices) {object.geometry.verticesNeedUpdate = true;object.selfUpdateVertices()};

					//THIS IS THE SUPER KEY !!!
					//if (object.geometry) {object.geometry.verticesNeedUpdate = true;}
					//THIS RIGHT HERE!!^^!!^^!!!!!
				}

				renderer.render( scene, camera );

			}

			var intervalator;
			function setKeySpeed (newSpeed) {
				clearInterval(intervalator);
				intervalator= setInterval(mintKeysAndMap,newSpeed);
			}
			function FAST_TIMES(){setKeySpeed(500)};
			function SLOW_TIMES(){setKeySpeed(5000)};

			init();
			intervalator = setInterval(mintKeysAndMap,1600);
			camera.updateProjectionMatrix();
			animate();


		</script><div><canvas width="738" height="639" style="width: 738px; height: 639px;"></canvas></div>


</body></html>
